=== debian/changelog ===
libopenshot (0.2.0+dfsg2-0.1~mx15+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 02 Jul 2018 16:41:23 -0700

libopenshot (0.2.0+dfsg2+685+201806302127+daily~ubuntu17.10.1) artful; urgency=low

  * Auto build.

 -- OpenShot Code <openshot.code@lists.launchpad.net>  Sat, 30 Jun 2018 21:27:53 +0000

libopenshot (0.2.0-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Sat, 30 Jun 2018 01:26:24 -0500

libopenshot (0.1.9-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Sun, 12 Nov 2017 03:52:39 -0600

libopenshot (0.1.8-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Wed, 06 Sep 2017 23:16:25 -0500

libopenshot (0.1.7-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Wed, 31 May 2017 23:47:40 -0500

libopenshot (0.1.6-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Thu, 18 May 2017 17:24:41 -0500

libopenshot (0.1.5-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Tue, 09 May 2017 23:59:15 -0500

libopenshot (0.1.4-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Thu, 30 Mar 2017 22:31:46 -0500

libopenshot (0.1.3-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Tue, 20 Dec 2016 17:04:49 -0600
