## libopenshot 0.2.2+dfsg1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -37,12 +37,12 @@
 ENDIF(WIN32)
 IF (APPLE)
 	# If you still get errors compiling with GCC 4.8, mac headers need to be patched: http://hamelot.co.uk/programming/osx-gcc-dispatch_block_t-has-not-been-declared-invalid-typedef/
-    SET_PROPERTY(GLOBAL PROPERTY JUCE_MAC "JUCE_MAC")
-    ADD_DEFINITIONS(-DNDEBUG)
-    SET(EXTENSION "mm")
-    
-    SET(JUCE_PLATFORM_SPECIFIC_DIR build/macosx/platform_specific_code)
-    SET(JUCE_PLATFORM_SPECIFIC_LIBRARIES "-framework Carbon -framework Cocoa -framework CoreFoundation -framework CoreAudio -framework CoreMidi -framework IOKit -framework AGL -framework AudioToolbox -framework QuartzCore -lobjc -framework Accelerate")
+	SET_PROPERTY(GLOBAL PROPERTY JUCE_MAC "JUCE_MAC")
+	ADD_DEFINITIONS(-DNDEBUG)
+	SET(EXTENSION "mm")
+
+	SET(JUCE_PLATFORM_SPECIFIC_DIR build/macosx/platform_specific_code)
+	SET(JUCE_PLATFORM_SPECIFIC_LIBRARIES "-framework Carbon -framework Cocoa -framework CoreFoundation -framework CoreAudio -framework CoreMidi -framework IOKit -framework AGL -framework AudioToolbox -framework QuartzCore -lobjc -framework Accelerate")
 ENDIF(APPLE)
 
 ################ IMAGE MAGICK ##################
@@ -74,13 +74,43 @@
 	SET(CMAKE_SWIG_FLAGS "-DUSE_IMAGEMAGICK=1")
 
 ENDIF (ImageMagick_FOUND)
-	
+
 ################### FFMPEG #####################
 # Find FFmpeg libraries (used for video encoding / decoding)
 FIND_PACKAGE(FFmpeg REQUIRED)
 
 # Include FFmpeg headers (needed for compile)
-include_directories(${FFMPEG_INCLUDE_DIR})
+message('AVCODEC_FOUND: ${AVCODEC_FOUND}')
+message('AVCODEC_INCLUDE_DIRS: ${AVCODEC_INCLUDE_DIRS}')
+message('AVCODEC_LIBRARIES: ${AVCODEC_LIBRARIES}')
+
+IF (AVCODEC_FOUND)
+	include_directories(${AVCODEC_INCLUDE_DIRS})
+ENDIF (AVCODEC_FOUND)
+IF (AVDEVICE_FOUND)
+	include_directories(${AVDEVICE_INCLUDE_DIRS})
+ENDIF (AVDEVICE_FOUND)
+IF (AVFORMAT_FOUND)
+	include_directories(${AVFORMAT_INCLUDE_DIRS})
+ENDIF (AVFORMAT_FOUND)
+IF (AVFILTER_FOUND)
+	include_directories(${AVFILTER_INCLUDE_DIRS})
+ENDIF (AVFILTER_FOUND)
+IF (AVUTIL_FOUND)
+	include_directories(${AVUTIL_INCLUDE_DIRS})
+ENDIF (AVUTIL_FOUND)
+IF (POSTPROC_FOUND)
+	include_directories(${POSTPROC_INCLUDE_DIRS})
+ENDIF (POSTPROC_FOUND)
+IF (SWSCALE_FOUND)
+	include_directories(${SWSCALE_INCLUDE_DIRS})
+ENDIF (SWSCALE_FOUND)
+IF (SWRESAMPLE_FOUND)
+	include_directories(${SWRESAMPLE_INCLUDE_DIRS})
+ENDIF (SWRESAMPLE_FOUND)
+IF (AVRESAMPLE_FOUND)
+	include_directories(${AVRESAMPLE_INCLUDE_DIRS})
+ENDIF (AVRESAMPLE_FOUND)
 
 ################# LIBOPENSHOT-AUDIO ###################
 # Find JUCE-based openshot Audio libraries
@@ -112,11 +142,11 @@
 add_definitions(${Qt5Multimedia_DEFINITIONS})
 add_definitions(${Qt5MultimediaWidgets_DEFINITIONS})
 
-SET(QT_LIBRARIES ${Qt5Widgets_LIBRARIES} 
-				 ${Qt5Core_LIBRARIES}
-				 ${Qt5Gui_LIBRARIES}
-				 ${Qt5Multimedia_LIBRARIES}
-				 ${Qt5MultimediaWidgets_LIBRARIES})
+SET(QT_LIBRARIES ${Qt5Widgets_LIBRARIES}
+		${Qt5Core_LIBRARIES}
+		${Qt5Gui_LIBRARIES}
+		${Qt5Multimedia_LIBRARIES}
+		${Qt5MultimediaWidgets_LIBRARIES})
 
 # Set compiler flags for Qt
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ")
@@ -133,15 +163,15 @@
 # Find BlackMagic DeckLinkAPI libraries
 IF (ENABLE_BLACKMAGIC)
 	FIND_PACKAGE(BlackMagic)
-	
+
 	IF (BLACKMAGIC_FOUND)
 		# Include headers (needed for compile)
 		include_directories(${BLACKMAGIC_INCLUDE_DIR})
-		
+
 		# define a global var (used in the C++)
 		add_definitions( -DUSE_BLACKMAGIC=1 )
 		SET(CMAKE_SWIG_FLAGS "-DUSE_BLACKMAGIC=1")
-		
+
 	ENDIF (BLACKMAGIC_FOUND)
 ENDIF (ENABLE_BLACKMAGIC)
 
@@ -150,14 +180,14 @@
 FIND_PACKAGE(OpenMP)
 
 if (OPENMP_FOUND)
-   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ")
 endif(OPENMP_FOUND)
 
 ################### ZEROMQ #####################
 # Find ZeroMQ library (used for socket communication & logging)
 FIND_PACKAGE(ZMQ REQUIRED)
 
-# Include FFmpeg headers (needed for compile)
+# Include ZeroMQ headers (needed for compile)
 include_directories(${ZMQ_INCLUDE_DIRS})
 
 ################### JSONCPP #####################
@@ -182,8 +212,8 @@
 
 ###############  SET LIBRARY SOURCE FILES  #################
 SET ( OPENSHOT_SOURCE_FILES
-  		AudioBufferSource.cpp
-  		AudioReaderSource.cpp
+		AudioBufferSource.cpp
+		AudioReaderSource.cpp
 		AudioResampler.cpp
 		CacheBase.cpp
 		CacheDisk.cpp
@@ -215,37 +245,37 @@
 		QtImageReader.cpp
 		QtPlayer.cpp
 		Timeline.cpp
-		
+
 		# Qt Video Player
 		${QT_PLAYER_FILES}
 		${MOC_FILES})
 
-		IF (NOT USE_SYSTEM_JSONCPP)
-			# Third Party JSON Parser
-			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
-				../thirdparty/jsoncpp/src/lib_json/json_reader.cpp
-				../thirdparty/jsoncpp/src/lib_json/json_value.cpp
-				../thirdparty/jsoncpp/src/lib_json/json_writer.cpp)
-		ENDIF (NOT USE_SYSTEM_JSONCPP)
-
-		# ImageMagic related files
-		IF (ImageMagick_FOUND)
-			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
-					ImageReader.cpp
-					ImageWriter.cpp
-					TextReader.cpp)
-		ENDIF (ImageMagick_FOUND)
-
-		# BlackMagic related files
-		IF (BLACKMAGIC_FOUND)
-			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES} 
-				DecklinkInput.cpp
-				DecklinkReader.cpp
-				DecklinkOutput.cpp
-				DecklinkWriter.cpp)
-		ENDIF (BLACKMAGIC_FOUND)
-		
-		
+IF (NOT USE_SYSTEM_JSONCPP)
+	# Third Party JSON Parser
+	SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
+			../thirdparty/jsoncpp/src/lib_json/json_reader.cpp
+			../thirdparty/jsoncpp/src/lib_json/json_value.cpp
+			../thirdparty/jsoncpp/src/lib_json/json_writer.cpp)
+ENDIF (NOT USE_SYSTEM_JSONCPP)
+
+# ImageMagic related files
+IF (ImageMagick_FOUND)
+	SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
+			ImageReader.cpp
+			ImageWriter.cpp
+			TextReader.cpp)
+ENDIF (ImageMagick_FOUND)
+
+# BlackMagic related files
+IF (BLACKMAGIC_FOUND)
+	SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
+			DecklinkInput.cpp
+			DecklinkReader.cpp
+			DecklinkOutput.cpp
+			DecklinkWriter.cpp)
+ENDIF (BLACKMAGIC_FOUND)
+
+
 # Get list of headers
 file(GLOB_RECURSE headers ${CMAKE_SOURCE_DIR}/include/*.h)
 
@@ -254,44 +284,71 @@
 
 ############### CREATE LIBRARY #################
 # Create shared openshot library
-add_library(openshot SHARED 
-			${OPENSHOT_SOURCE_FILES}
-			${headers} )
+add_library(openshot SHARED
+		${OPENSHOT_SOURCE_FILES}
+		${headers} )
 
 # Set SONAME and other library properties
 set_target_properties(openshot
-			PROPERTIES
-			VERSION ${PROJECT_VERSION}
-			SOVERSION ${SO_VERSION} 
-			INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
-            )
+		PROPERTIES
+		VERSION ${PROJECT_VERSION}
+		SOVERSION ${SO_VERSION}
+		INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
+		)
 
 ###############  LINK LIBRARY  #################
 SET ( REQUIRED_LIBRARIES
-		${FFMPEG_LIBRARIES}
 		${LIBOPENSHOT_AUDIO_LIBRARIES}
 		${QT_LIBRARIES}
 		${PROFILER}
 		${JSONCPP_LIBRARY}
 		${ZMQ_LIBRARIES}
 		)
-		
-		IF (OPENMP_FOUND)
-			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${OpenMP_CXX_FLAGS} )
-		ENDIF (OPENMP_FOUND)
-		
-		IF (ImageMagick_FOUND)
-			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${ImageMagick_LIBRARIES} )
-		ENDIF (ImageMagick_FOUND)
-
-		IF (BLACKMAGIC_FOUND)
-			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${BLACKMAGIC_LIBRARY_DIR} )
-		ENDIF (BLACKMAGIC_FOUND)
-
-		IF (WIN32)
-			# Required for exception handling on Windows
-			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} "imagehlp" "dbghelp" )
-		ENDIF(WIN32)
+
+IF (AVCODEC_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVCODEC_LIBRARIES} )
+ENDIF (AVCODEC_FOUND)
+IF (AVDEVICE_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVDEVICE_LIBRARIES} )
+ENDIF (AVDEVICE_FOUND)
+IF (AVFORMAT_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVFORMAT_LIBRARIES} )
+ENDIF (AVFORMAT_FOUND)
+IF (AVFILTER_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVFILTER_LIBRARIES} )
+ENDIF (AVFILTER_FOUND)
+IF (AVUTIL_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVUTIL_LIBRARIES} )
+ENDIF (AVUTIL_FOUND)
+IF (POSTPROC_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${POSTPROC_LIBRARIES} )
+ENDIF (POSTPROC_FOUND)
+IF (SWSCALE_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${SWSCALE_LIBRARIES} )
+ENDIF (SWSCALE_FOUND)
+IF (SWRESAMPLE_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${SWRESAMPLE_LIBRARIES} )
+ENDIF (SWRESAMPLE_FOUND)
+IF (AVRESAMPLE_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${AVRESAMPLE_LIBRARIES} )
+ENDIF (AVRESAMPLE_FOUND)
+
+IF (OPENMP_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${OpenMP_CXX_FLAGS} )
+ENDIF (OPENMP_FOUND)
+
+IF (ImageMagick_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${ImageMagick_LIBRARIES} )
+ENDIF (ImageMagick_FOUND)
+
+IF (BLACKMAGIC_FOUND)
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${BLACKMAGIC_LIBRARY_DIR} )
+ENDIF (BLACKMAGIC_FOUND)
+
+IF (WIN32)
+	# Required for exception handling on Windows
+	SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} "imagehlp" "dbghelp" )
+ENDIF(WIN32)
 
 # Link all referenced libraries
 target_link_libraries(openshot ${REQUIRED_LIBRARIES})
@@ -304,50 +361,3 @@
 # Link test executable to the new library
 target_link_libraries(openshot-example openshot)
 
-############### PLAYER EXECUTABLE ################
-# Create test executable
-add_executable(openshot-player Qt/demo/main.cpp)
-
-# Link test executable to the new library
-target_link_libraries(openshot-player openshot)
-
-############### TEST BLACKMAGIC CAPTURE APP ################
-IF (BLACKMAGIC_FOUND)
-	# Create test executable
-	add_executable(openshot-blackmagic 
-				   examples/ExampleBlackmagic.cpp)
-	
-	# Link test executable to the new library
-	target_link_libraries(openshot-blackmagic openshot)
-ENDIF (BLACKMAGIC_FOUND)
-
-############### INCLUDE SWIG BINDINGS ################
-add_subdirectory(bindings)
-
-
-############### INSTALL HEADERS & LIBRARY ################
-set(LIB_INSTALL_DIR lib${LIB_SUFFIX}) # determine correct lib folder
-
-# Install primary library
-INSTALL(  TARGETS openshot
-  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
-  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
-  COMPONENT library )
-	
-INSTALL(FILES ${headers} 
-	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/libopenshot )
-
-
-############### CPACK PACKAGING ##############
-IF(MINGW)
-	SET(CPACK_GENERATOR "NSIS")
-ENDIF(MINGW)
-IF(UNIX AND NOT APPLE)
-	SET(CPACK_GENERATOR "DEB")
-ENDIF(UNIX AND NOT APPLE)
-#IF(UNIX AND APPLE)
-#	SET(CPACK_GENERATOR "DragNDrop")
-#ENDIF(UNIX AND APPLE)
-SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Jonathan Thomas") #required
-
-INCLUDE(CPack)
