=== src/bindings/python/CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,12 @@
 		SWIG_LINK_LIBRARIES(openshot ${PYTHON_LIBRARIES} openshot)
 
 		### FIND THE PYTHON INTERPRETER (AND THE SITE PACKAGES FOLDER)
-		SET(PYTHON_MODULE_PATH "lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages")
+		EXECUTE_PROCESS ( COMMAND ${PYTHON_EXECUTABLE} -c "import site; print(site.getsitepackages()[0])"
+		                     OUTPUT_VARIABLE _ABS_PYTHON_MODULE_PATH
+		                     OUTPUT_STRIP_TRAILING_WHITESPACE )
+		GET_FILENAME_COMPONENT(_ABS_PYTHON_MODULE_PATH "${_ABS_PYTHON_MODULE_PATH}" ABSOLUTE)
+		FILE(RELATIVE_PATH _REL_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX} ${_ABS_PYTHON_MODULE_PATH})
+		SET(PYTHON_MODULE_PATH ${_REL_PYTHON_MODULE_PATH})
 
 		############### INSTALL HEADERS & LIBRARY ################
 		### Install Python bindings
