=== debian/changelog ===
libopenshot (0.2.2+dfsg1-1ubuntu3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Mar 2020 18:42:00 +0100

libopenshot (0.2.2+dfsg1-1ubuntu2) focal; urgency=medium

  * Build using g++-8.
  * Search Python 3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:33:41 +0000

libopenshot (0.2.2+dfsg1-1build1) disco; urgency=medium

  * No-change rebuild to build for python3.7 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 31 Oct 2018 12:35:32 +0000

libopenshot (0.2.2+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.2.2+dfsg1
    - This version should be compatible with ffmpeg 3 and 4.
    - Drop patch for ffmpeg 4, no longer needed
    - Bump .so version to 16
  * Update Standards-Version to 4.2.1, no changes needed
  * Remove Multi-Arch field from python3-openshot, fixes a lintian warning

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 22 Sep 2018 22:41:04 +0200

libopenshot (0.2.0+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.2.0+dfsg1
  * Update patches
  * Bump soversion to 15
  * Update Standards-Version to 4.2.0, no changes needed
  * Fix wrong path for doc-base files

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 21 Aug 2018 16:56:42 +0200

libopenshot (0.1.9+dfsg1-4) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ James Cowgill ]
  * Add patch to fix FTBFS with FFmpeg 4.0 (Closes: #888364)

  [ Dr. Tobias Quathamer ]
  * Use debhelper v11
  * Update to Standards-Version 4.1.4, no changes needed

  [ Sebastian Ramacher ]
  * debian/control: Bump Standards-Version.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 11 Jul 2018 21:09:07 +0200
