=== debian/changelog ===
libopenshot (0.2.2.1+dfsg+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>  Mon, 01 Feb 2021 16:03:29 +0800
