=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,4 @@
 #!/usr/bin/make -f
-
-export CC = gcc-8
-export CXX = g++-8
 
 include /usr/share/dpkg/architecture.mk
 
@@ -12,6 +9,10 @@
 # Possible overlinkage.
 # see: https://github.com/OpenShot/libopenshot/issues/38
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+ifeq ($(DEB_HOST_ARCH_CPU),arm)
+        export DEB_BUILD_OPTIONS=nocheck
+endif
 
 %:
 	dh $@ --with python3
@@ -27,8 +28,6 @@
 
 override_dh_auto_test-indep:
 
-override_dh_auto_test-arch:
-
 override_dh_auto_install-indep:
 
 override_dh_installdocs-indep:
